杭电 1069 Monkey and Banana

来源:互联网 发布:网络兼职写小说 编辑:程序博客网 时间:2024/06/05 16:25

http://acm.hdu.edu.cn/showproblem.php?pid=1069

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7397    Accepted Submission(s): 3801


Problem Description
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
 

Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
 

Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
 

Sample Input
110 20 3026 8 105 5 571 1 12 2 23 3 34 4 45 5 56 6 67 7 7531 41 5926 53 5897 93 2384 62 6433 83 270
 

Sample Output
Case 1: maximum height = 40Case 2: maximum height = 21Case 3: maximum height = 28Case 4: maximum height = 342
 
题意理解与分析:每一个长方体都可以有三种不同的放法,就像输入的三条边有三种长宽高的安排法,因为个数不限,严格递减(递增)所以可以把每三条边的三种情况都存下来,排序就可以了,其实刚开始的时候能这样想有点难度,自己仔细想想,回味一下还是蛮有趣的。
AC代码:
#include<iostream>#include<cstring>#include<cstdio>#include<algorithm>using namespace std;struct node{    int x,y,z,h;}s[100];int n,dp[100];bool cmp(node a,node b){    if(a.x==b.x)        return a.y>b.y;    return a.x>b.x;}int DP(){    sort(s,s+n,cmp);    int maxh=0;    for(int i=0;i<n;i++)    {        dp[i]=s[i].z;        for(int j=i-1;j>=0;j--)            if(s[j].x>s[i].x&&s[j].y>s[i].y)//严格递减                   if(dp[j]+s[i].z>dp[i])                      dp[i]=s[i].z+dp[j];        if(dp[i]>maxh)            maxh=dp[i];    }    return maxh;}int main(){    int i,j,ant=1,a,b,c;    while(~scanf("%d",&n),n)    {        for(i=0,j=0;j<n;j++)        {            scanf("%d%d%d",&a,&b,&c);//接下来是这三个数拼的长方体的长、宽、高的三种情况。            s[i].x=min(a,b);//宽            s[i].y=max(a,b);//长            s[i].z=c;            s[i+1].x=min(a,c);            s[i+1].y=max(a,c);            s[i+1].z=b;            s[i+2].x=min(b,c);            s[i+2].y=max(b,c);            s[i+2].z=a;            i+=3;        }        n=i;        printf("Case %d: maximum height = %d\n",ant++,DP());    }    return 0;}



1 0
原创粉丝点击